<!-- eslint-disable vue/no-mutating-props -->
<template>
	<div class="flex-col bg-white px-4 md:px-6 lg:px-10 py-6 lg:py-10 mb-2 md:mb-8 lg:mb-20">
		<MkStepProgress
			:step-title="page.payment"
			:step-number="stepNumber"
			:class-active="stepsCompleted == 4 ? 'active' : ''"
		/>
		<div v-if="stepsCompleted == 4">
			<ValidationObserver ref="payment_method_validation_observer">
				<MkToggleBtn
					:value="value['useBillingAddress']"
					:address="newShippingAddress"
					class="md:my-8"
					@change="toggle_billing_address()"
				/>
				<div v-if="!addressSaved">
					<MkSelectDropdown
						v-if="AUTHENTICATED && address.length > 0 && !value['useBillingAddress']"
						id="shipping_address"
						aria-label="Billing address"
						:value="selectedBillingAddress.billingAddressId || selectedBillingAddress.shippingAddressId"
						label="New address"
						:options="address"
						:source="true"
						@change="setBillingAddress($event)"
					/>
					<MkAddressForm
						v-if="
							(!value['useBillingAddress'] && adddressText == 'New Address') ||
							(!value['useBillingAddress'] && adddressText == '')
						"
						id="checkout_billing_form"
						v-model="value['addressData']"
						:address-data="value['addressData']"
						:prefix="''"
					/>
					<div v-if="!value['useBillingAddress']" class="flex justify-center items-center mt-5">
						<MkPrimaryButton
							:disabled="disableTrue"
							btn-class="min-w-150 py-2 h-10"
							:loading="loading"
							button-title="Save address"
							font-size="text-xl"
							@click="checkCardPresent()"
						/>
					</div>
				</div>
			</ValidationObserver>
			<ValidationObserver ref="payment_card_validation_observer">
				<MkAddNewAddressTitle
					tabindex="0"
					role="button"
					class="lg:mt-8 md:mt-6 mt-8"
					title=" credit card"
					:show-add="showAdd"
					@add-address="showCard()"
				/>
				<!-- <div tabindex="0"  role="button" :class="{'mt-5':addressSaved}" class="flex items-center cursor-pointer focus:ring-black" @keypress.enter="showCard" @keypress.space="showCard" @click="showCard()">
          <img v-if="!showAdd" src="~/assets/images/combined-shape.svg" class="h-4 w-4" alt="Add new credit card">
          <img v-else src="~/assets/images/combined-shape-minus.svg" class="h-4 w-4" alt="Remove new credit card">
          <p class="font-primary-font-bold text-base leading-6 pl-4">Add new credit card</p>
        </div>  -->
				<MKAdyen v-if="this.$store.state.paymentGateway === 'adyen' && showAdd" @card-filled="cardFilled" />
				<MkAddNewCreditcard v-else-if="showAdd" class="w-full md:w-460 lg:w-610" @card-filled="cardFilled" />
				<div v-if="showAdd && !GUEST_USER" class="flex justify-center items-center mt-6 md:mt-8 lg:mt-10 mb-6 md:mb-10">
					<MkPrimaryButton
						:disabled="disableTrue || !cardDetailsFilled"
						btn-class="min-w-150 py-2 h-10"
						:loading="loading"
						button-title="Save"
						font-size="text-xl"
						@click="saveCard()"
					/>
				</div>
			</ValidationObserver>
			<MKSpinnerAnimation v-if="ACCOUNT_RESPONSE_WAIT" size-class="w-10 h-10 md:w-460 lg:w-610" />
			<MkCreditCard
				v-else-if="CUSTOMER_CREDIT_CARD_DETAILS.length > 0"
				:credit-cards="CUSTOMER_CREDIT_CARD_DETAILS"
				:recent-payment="RECENT_PAYMENT"
				:card-selected="value.selectedCard"
				@selected-card="setSelectedCard"
			/>
			<MkMonthlyPayments
				v-if="FEATURE_AFFIRM"
				:is-affirm="value.selectedAffirm"
				:class="{ 'mt-6 lg:mt-8': !AUTHENTICATED }"
				@affirm-selected="setAffirmSelected"
			/>
		</div>
	</div>
</template>
<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkAddressForm from '~/components/D2C/molecules/MkAddressForm.vue';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkToggleBtn from '~/components/D2C/atoms/MkToggleBtn.vue';
import MkCreditCard from '~/components/D2C/atoms/MkCreditCard.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkMonthlyPayments from '~/components/D2C/atoms/MkMonthlyPayments.vue';
import MkAddNewCreditcard from '~/components/D2C/atoms/MkAddNewCreditcard.vue';
import MkSelectDropdown from '~/components/D2C/atoms/MkSelectDropdown.vue';
import MKSpinnerAnimation from '~/components/D2C/atoms/MKSpinnerAnimation.vue';
import MkAddNewAddressTitle from '~/components/D2C/atoms/MkAddNewAddressTitle.vue';
import MKAdyen from '~/components/D2C/molecules/MKAdyen.vue';
export default {
	name: 'MkCheckoutPayment',
	components: {
		MkStepProgress,
		MkAddressForm,
		MkToggleBtn,
		MkCreditCard,
		MkMonthlyPayments,
		MkPrimaryButton,
		MkAddNewCreditcard,
		ValidationObserver,
		MkSelectDropdown,
		MKSpinnerAnimation,
		MkAddNewAddressTitle,
		MKAdyen,
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: () => 0,
		},
		value: {
			type: Object,
			default: () => {},
		},
		shippingAddress: {
			type: Object,
			default: () => {},
		},
		page: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			loading: false,
			stepNumber: 4,
			showAdd: false,
			selectedBillingAddress: { shippingAddressId: '' },
			address: [],
			disableTrue: false,
			addressSaved: false,
			newShippingAddress: {},
			adddressText: '',
			cardDetailsFilled: false,
		};
	},
	computed: {
		...mapState('USER_STORE', [
			'ADDRESS',
			'AUTHENTICATED',
			'ACCOUNT_RESPONSE_WAIT',
			'RECENT_PAYMENT',
			'CUSTOMER_SHIPPING_ADDRESS',
			'CUSTOMER_CREDIT_CARD_DETAILS',
			'VALID_ADDRESS',
		]),
		...mapState('CART_STORE', ['GUEST_USER']),
		...mapState('CHECKOUT_STORE', ['FEATURE_AFFIRM']),
		...mapState(['isEurope']),
	},
	watch: {
		CUSTOMER_SHIPPING_ADDRESS: {
			deep: true,
			handler() {
				this.setAddressDropdown();
			},
		},
		value: {
			deep: true,
			handler() {
				this.checkDataFilled();
			},
		},
		shippingAddress: {
			deep: true,
			handler() {
				this.checkShippingAddress();
			},
		},
	},
	mounted() {
		this.setAddressDropdown();
	},
	methods: {
		cardFilled(value) {
			this.cardDetailsFilled = value;
		},
		setAddressDropdown() {
			const $savedAddress = [];
			if (this.CUSTOMER_SHIPPING_ADDRESS.length > 0) {
				this.CUSTOMER_SHIPPING_ADDRESS.forEach(($el, $i) => {
					const $obj = {
						streetAddress1: $el.streetName,
						streetAddress2: $el.streetNumber,
						shippingAddressId: $el.id,
						id: $el.id,
						phoneNumber: $el.phone,
						city: $el.city,
						state: $el.state,
						country: $el.country,
						firstName: $el.firstName,
						lastName: $el.lastName,
						postalCode: $el.postalCode,
						isDefault: $el.isDefault || false,
					};
					if ($obj.streetAddress1) {
						const $address =
							$obj.streetAddress1 +
							', ' +
							($obj.streetAddress2 ? $obj.streetAddress2 + ', ' : '') +
							$obj.city +
							', ' +
							($obj.state ? $obj.state + ', ' : '') +
							$obj.postalCode;
						$savedAddress.push({
							value: $obj.shippingAddressId || $obj.billingAddressId,
							isDefault: $obj.isDefault,
							text: $address,
							obj: $obj,
						});
					}
				});
			}
			this.address = $savedAddress;
			this.address.unshift({
				value: '1',
				isDefault: false,
				text: 'New Address',
				obj: {
					city: '',
					country: '',
					firstName: '',
					isDefault: false,
					lastName: '',
					phoneNumber: '',
					postalCode: '',
					shippingAddressId: '',
					state: '',
					streetAddress1: '',
					streetAddress2: '',
				},
			});
		},
		checkShippingAddress() {
			if (this.value.useBillingAddress) {
				this.newShippingAddress = this.shippingAddress;
				this.$set(this.value, 'shippingAddress', this.shippingAddress);
			}
		},
		setSelectedCard($card) {
			this.value.selectedCard = $card; // eslint-disable-line
			if (this.value.selectedAffirm) {
				this.value.selectedAffirm = false; // eslint-disable-line
			}
			this.$set(this.value, 'selectedCard', $card);
			this.$forceUpdate();
		},
		setAffirmSelected($data) {
			if ($data) {
				this.value.selectedCard = {}; // eslint-disable-line
			}
			this.$set(this.value, 'selectedAffirm', $data);
		},
		setBillingAddress($id) {
			const $selectedAddress = this.address.filter(($obj) => {
				return $obj.value === $id;
			});
			this.adddressText = $selectedAddress[0].text;
			this.selectedBillingAddress = $selectedAddress[0].obj;
			this.value.addressData = this.selectedBillingAddress; // eslint-disable-line
		},
		async checkCardPresent() {
			const isValidForm = await this.$refs.payment_method_validation_observer.validate();
			if (isValidForm && this.VALID_ADDRESS) {
				this.addressSaved = true;
				this.newShippingAddress = this.value.addressData;
			}
		},
		async saveCard() {
			const isValidForm = await this.$refs.payment_card_validation_observer.validate();
			if (isValidForm && !this.disableTrue) {
				this.addCard();
			}
		},
		async addCard() {
			try {
				this.loading = true;
				let $address = {};
				if (this.value.useBillingAddress) {
					$address = this.newShippingAddress;
				} else {
					$address = this.value.addressData;
				}
				$address.streetName = $address.streetAddress1;
				$address.streetNumber = $address.streetAddress2 ? $address.streetAddress2 : '';
				$address.phone = $address.phoneNumber;
				$address.isBusiness = false;
				$address.company = $address.companyName;
				$address.region = $address.state;
				const $data = {
					action: 'ADD_PAYMENT',
					billingAddress: $address,
					isDefaultPayment: false,
				};
				// const cardAdded = await this.$store.dispatch('USER_STORE/ADD_CREDIT_CARD', {billingAddress:$address , defaultPayment : false});
				const responseMsg = await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', $data);
				if (responseMsg === 'Error') {
					this.showAdd = true;
					this.addressSaved = false;
				} else {
					this.showAdd = false;
					this.addressSaved = true;
					await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
					this.$forceUpdate();
				}
				this.loading = this.ACCOUNT_RESPONSE_WAIT;
			} catch (error) {
				this.warning = true;
			}
		},
		toggle_billing_address(value) {
			if (this.value.useBillingAddress) {
				this.value.useBillingAddress = false; // eslint-disable-line
				// eslint-disable-next-line vue/no-mutating-props
				this.value.addressData = {
					firstName: '',
					lastName: '',
					streetAddress1: '',
					streetAddress2: '',
					city: '',
					state: '',
					postalCode: '',
					phoneNumber: '',
					country: 'US',
				};
				this.disableTrue = true;
				this.addressSaved = false;
				if (this.selectedBillingAddress.city) {
					this.value.addressData = this.selectedBillingAddress; // eslint-disable-line
				}
			} else {
				this.value.useBillingAddress = true; // eslint-disable-line
				this.value.addressData = this.selectedBillingAddress; // eslint-disable-line
				this.newShippingAddress = this.shippingAddress;
				this.disableTrue = false;
				this.addressSaved = false;
			}
		},
		showCard() {
			this.showAdd = !this.showAdd;
			this.cardDetailsFilled = false;
		},
		checkDataFilled() {
			const address = this.value.addressData;
			if (!this.value.useBillingAddress) {
				if (
					address.streetAddress1 &&
					address.city &&
					address.country &&
					address.firstName &&
					address.lastName &&
					address.phoneNumber &&
					address.postalCode &&
					(this.isEurope ? true : address.state)
				) {
					this.disableTrue = false;
				} else {
					this.disableTrue = true;
				}
			} else {
				this.value.addressData = this.selectedBillingAddress; // eslint-disable-line
				this.disableTrue = false;
			}
		},
	},
};
</script>
